var LOG_ENABLED = true;

if (!Function.prototype.bind) {
  Function.prototype.bind = function(oThis) {
    if (typeof this !== 'function') {
      // ECMAScript 5 내부 IsCallable 함수와
      // 가능한 가장 가까운 것
      throw new TypeError('Function.prototype.bind - what is trying to be bound is not callable');
    }

    var aArgs   = Array.prototype.slice.call(arguments, 1),
        fToBind = this,
        fNOP    = function() {},
        fBound  = function() {
          return fToBind.apply(this instanceof fNOP
                 ? this
                 : oThis,
                 aArgs.concat(Array.prototype.slice.call(arguments)));
        };

    if (this.prototype) {
      // Function.prototype은 prototype 속성이 없음
      fNOP.prototype = this.prototype;
    }
    fBound.prototype = new fNOP();

    return fBound;
  };
}

function setDebug(isDebug) {
	if (isDebug) {
		window.debug = {
			// log: window.console.log.bind(window.console, '%s: %s'),
			// error: window.console.error.bind(window.console, 'error: %s'),
			// info: window.console.info.bind(window.console, 'info: %s'),
			// warn: window.console.warn.bind(window.console, 'warn: %s')
			log: console.log.bind(console),
			error: console.error.bind(console),
			info: console.log.bind(console),
			warn: console.warn.bind(console)
		};
	} else {
		var __no_op = function() {};

		window.debug = {
			log: __no_op,
			error: __no_op,
			warn: __no_op,
			info: __no_op
		}
	}
}

setDebug(LOG_ENABLED);

