var HCAP = {
	name: "HCAP",
	information: "HTML" + hcap.API_VERSION,
	versions: "",
	eventCB: null,
	connectionStatusCB: null,

	getBridgeStatus: function (paramObj) {
		debug.info("getBridgeStatus: paramObj[" + JSON.stringify(paramObj) + 
			"]");

		var param = {
			"bridgeUid": paramObj.bridgeUid,
			"onSuccess": function(s) {
				debug.info("getBridgeStatus: onSuccess : status[" + s.status + 
					"]");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": true,
					"status": s.status,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);

			}, 
			"onFailure" : function(f) {
				debug.error("getBridgeStatus: onFailure : errorMessage[" + 
					f.errorMessage + "]");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": false,
					"errorMessage": f.errorMessage,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);
			}
		};

		hcap.iot.getBridgeStatus(param);
	},
	getFrameworkStatus: function (paramObj) {
		debug.info("getFrameworkStatus: paramObj[" + JSON.stringify(paramObj) + 
			"]");

		var param = {
			"onSuccess": function(s) {
				debug.info("getFrameworkStatus: onSuccess : status[" + 
					s.status + "]");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": true,
					"status": s.status,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);

			}, 
			"onFailure" : function(f) {
				debug.error("getFrameworkStatus: onFailure : errorMessage[" + 
					f.errorMessage + "]");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": false,
					"errorMessage": f.errorMessage,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);

			}
		};

		hcap.iot.getFrameworkStatus(param);
	},
	getThingList: function (paramObj) {
		debug.info("getThingList: paramObj[" + JSON.stringify(paramObj) + "]");

		var param = {
			"onSuccess": function(s) {
				debug.info("getThingList: onSuccess : thingList[" + 
					JSON.stringify(s.thingList) + "]");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": true,
					"thingList": s.thingList,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);
			}, 
			"onFailure" : function(f) {
				debug.error("getThingList: onFailure : errorMessage[" + 
					f.errorMessage + "]");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": false,
					"errorMessage": f.errorMessage,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);
			}
		};

		if (paramObj.hasOwnProperty("thingUidList")) {
			param["thingUidList"] = paramObj.thingUidList;
		} else if (paramObj.hasOwnProperty("thingType")) {
			param["thingType"] = paramObj.thingType;
		}

		hcap.iot.getThingList(param);
	},
	requestRegisterThing: function (paramObj) {
		debug.info("requestRegisterThing: paramObj[" + 
			JSON.stringify(paramObj) + "]");

		var param = {
			"thingUid": paramObj.thingUid,
			"onSuccess": function(s) {
				debug.info("requestRegisterThing: onSuccess");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": true,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);
			}, 
			"onFailure" : function(f) {
				debug.error("requestRegisterThing: onFailure : errorMessage[" + 
					f.errorMessage + "]");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": false,
					"errorMessage": f.errorMessage,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);
			}
		};

		hcap.iot.requestRegisterThing(param);
	},
	requestRejectThing: function (paramObj) {
		debug.info("requestRejectThing: paramObj[" + JSON.stringify(paramObj) + 
			"]");

		var param = {
			"thingUid": paramObj.thingUid,
			"onSuccess": function(s) {
				debug.info("requestRejectThing: onSuccess");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": true,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);
			}, 
			"onFailure" : function(f) {
				debug.error("requestRejectThing: onFailure : errorMessage[" + 
					f.errorMessage + "]");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": false,
					"errorMessage": f.errorMessage,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);
			}
		};

		hcap.iot.requestRejectThing(param);
	},
	requestSetBridgeStatus: function (paramObj) {
		debug.info("requestSetBridgeStatus: paramObj[" + 
			JSON.stringify(paramObj) + "]");

		var param = {
			"bridgeUid": paramObj.bridgeUid,
			"status": paramObj.status,
			"onSuccess": function(s) {
				debug.info("requestSetBridgeStatus: onSuccess");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": true,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);
			}, 
			"onFailure" : function(f) {
				debug.error("requestSetBridgeStatus: onFailure : " +
					"errorMessage[" + f.errorMessage + "]");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": false,
					"errorMessage": f.errorMessage,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);
			}
		};

		hcap.iot.requestSetBridgeStatus(param);
	},
	requestSetComponent: function (paramObj) {
		debug.info("requestSetComponent: paramObj[" + 
			JSON.stringify(paramObj) + "]");

		var param = {
			"thingUid": paramObj.thingUid,
			"componentId": paramObj.componentId,
			"componentValue": paramObj.componentValue,
			"callId": paramObj.callId,
			"onSuccess": function(s) {
				debug.info("requestSetComponent: onSuccess");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": true,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);
			}, 
			"onFailure" : function(f) {
				debug.error("requestSetComponent: onFailure : errorMessage[" + 
					f.errorMessage + "]");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": false,
					"errorMessage": f.errorMessage,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);
			}
		};

		hcap.iot.requestSetComponent(param);
	},
	requestSynchronizeThing: function (paramObj) {
		debug.info("requestSynchronizeThing: paramObj[" + 
			JSON.stringify(paramObj) + "]");

		var param = {
			"thingUid": paramObj.thingUid,
			"componentId": paramObj.componentId,
			"onSuccess": function(s) {
				debug.info("requestSynchronizeThing: onSuccess");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": true,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);
			}, 
			"onFailure" : function(f) {
				debug.error("requestSynchronizeThing: onFailure : " +
					"errorMessage[" + f.errorMessage + "]");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": false,
					"errorMessage": f.errorMessage,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);
			}
		};

		hcap.iot.requestSynchronizeThing(param);
	},
	requestUnregisterThing: function (paramObj) {
		debug.info("requestUnregisterThing: paramObj[" + 
			JSON.stringify(paramObj) + "]");

		var param = {
			"thingUid": paramObj.thingUid,
			"onSuccess": function(s) {
				debug.info("requestUnregisterThing: onSuccess");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": true,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);
			}, 
			"onFailure" : function(f) {
				debug.error("requestUnregisterThing: onFailure : " +
					"errorMessage[" + f.errorMessage + "]");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": false,
					"errorMessage": f.errorMessage,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);
			}
		};

		hcap.iot.requestUnregisterThing(param);
	},
	setThingNickname: function (paramObj) {
		debug.info("setThingNickname: paramObj[" + JSON.stringify(paramObj) + 
			"]");

		var param = {
			"thingUid": paramObj.thingUid,
			"nickname": paramObj.nickname,
			"onSuccess": function(s) {
				debug.info("setThingNickname: onSuccess");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": true,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);
			}, 
			"onFailure" : function(f) {
				debug.error("setThingNickname: onFailure : errorMessage[" + 
					f.errorMessage + "]");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": false,
					"errorMessage": f.errorMessage,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);
			}
		};

		hcap.iot.setThingNickname(param);
	},
	getBindingIdList: function (paramObj) {
		debug.info("getBindingIdList: paramObj[" + JSON.stringify(paramObj) + 
			"]");

		var param = {
			"onSuccess": function(s) {
				debug.info("getBindingIdList: onSuccess : bindingIdList[" + 
					JSON.stringify(s.bindingIdList) + "]");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": true,
					"bindingIdList": s.bindingIdList,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);
			}, 
			"onFailure" : function(f) {
				debug.error("getBindingIdList: onFailure : errorMessage[" + 
					f.errorMessage + "]");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": false,
					"errorMessage": f.errorMessage,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);
			}
		};

		hcap.iot.getBindingIdList(param);
	},
	requestFactoryReset: function (paramObj) {
		debug.info("requestFactoryReset: paramObj[" + 
			JSON.stringify(paramObj) + "]");

		var param = {
			"bindingIdList": paramObj.bindingIdList,
			"onSuccess": function(s) {
				debug.info("requestFactoryReset: onSuccess");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": true,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);
			}, 
			"onFailure" : function(f) {
				debug.error("requestFactoryReset: onFailure : errorMessage[" + 
					f.errorMessage + "]");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": false,
					"errorMessage": f.errorMessage,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);
			}
		};

		hcap.iot.requestFactoryReset(param);
	},
	getVersions: function (paramObj) {
		debug.info("getVersions: paramObj[" + 
			JSON.stringify(paramObj) + "]");

		var param = {
			"onSuccess": function(s) {
				debug.info("getVersions: onSuccess");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": true,
					"paramObj": paramObj,
					"versions": s.versions
				}
				paramObj.CB(resultObj);
			}, 
			"onFailure" : function(f) {
				debug.error("getVersions: onFailure : errorMessage[" + 
					f.errorMessage + "]");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": false,
					"errorMessage": f.errorMessage,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);
			}
		};

		hcap.iot.getVersions(param);
	},
	reboot: function (paramObj) {
		debug.info("reboot: paramObj[" + 
			JSON.stringify(paramObj) + "]");

		var param = {
			"onSuccess": function(s) {
				debug.info("reboot: onSuccess");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": true,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);
			}, 
			"onFailure" : function(f) {
				debug.error("reboot: onFailure : errorMessage[" + 
					f.errorMessage + "]");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": false,
					"errorMessage": f.errorMessage,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);
			}
		};

		hcap.power.reboot(param);
	},
	setProperty: function (paramObj) {
		debug.info("setProperty: paramObj[" + JSON.stringify(paramObj) + 
			"]");

		var param = {
			"key": paramObj.key,
			"value": paramObj.value,
			"onSuccess": function(s) {
				debug.info("setProperty: onSuccess");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": true,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);
			}, 
			"onFailure" : function(f) {
				debug.error("setProperty: onFailure : errorMessage[" + 
					f.errorMessage + "]");

				var resultObj = {
					"callId": paramObj.callId,
					"returnValue": false,
					"errorMessage": f.errorMessage,
					"paramObj": paramObj,
				}
				paramObj.CB(resultObj);
			}
		};

		hcap.property.setProperty(param);
	},
};

document.addEventListener(
	"iot_bridge_status_changed", 
	function (param) {
		debug.info("Event 'iot_bridge_status_changed': bridgeUid[" + 
			param.bridgeUid + "], status[" + param.status + "]");

		if (HCAP.eventCB !== null) {
			if (HCAP.eventCB.hasOwnProperty("bridgeStatusChanged")) {
				var eventObj = {
					"bridgeUid": param.bridgeUid,
					"status": param.status
				};
				HCAP.eventCB["bridgeStatusChanged"](eventObj);
			}
		}
	},
	false
);

document.addEventListener(
	"iot_component_reported", 
	function (param) {
		debug.info("Event 'iot_component_reported': thingUid[" + 
			param.thingUid + "], componentId[" + param.componentId + 
			"], fromValue[" + JSON.stringify(param.fromValue) + 
			"], toValue[" + JSON.stringify(param.toValue) + "]");

		if (HCAP.eventCB !== null) {
			if (HCAP.eventCB.hasOwnProperty("componentReported")) {
				var eventObj = {
					"thingUid": param.thingUid,
					"componentId": param.componentId,
					"fromValue": param.fromValue,
					"toValue": param.toValue,
				};
				HCAP.eventCB["componentReported"](eventObj);
			}
		}
	},
	false
);

document.addEventListener(
	"iot_framework_status_changed",
	function (param) {
		debug.info("Event 'iot_framework_status_changed': status[" + 
			param.status + "]");

		if (HCAP.eventCB !== null) {
			if (HCAP.eventCB.hasOwnProperty("frameworkStatusChanged")) {
				var eventObj = {
					"status": param.status
				};
				HCAP.eventCB["frameworkStatusChanged"](eventObj);
			}
		}
	},
	false
);

document.addEventListener(
	"iot_set_component_result_received",
	function (param) {
		debug.info("Event 'iot_set_component_result_received': result[" + 
			param.result + "], callId[" + param.callId + "]");

		if (HCAP.eventCB !== null) {
			if (HCAP.eventCB.hasOwnProperty("setComponentResultReceived")) {
				var eventObj = {
					"result": param.result,
					"callId": param.callId,
				};
				HCAP.eventCB["setComponentResultReceived"](eventObj);
			}
		}
	},
	false
);

document.addEventListener(
	"iot_thing_discovered",
	function (param) {
		debug.info("Event 'iot_thing_discovered': bindingId[" + 
			param.bindingId + "], thingUid[" + param.thingUid + "], thingId[" +
			param.thingId + "], label[" + param.label + "]");

		if (HCAP.eventCB !== null) {
			if (HCAP.eventCB.hasOwnProperty("thingDiscovered")) {
				var eventObj = {
					"bindingId": param.bindingId,
					"thingUid": param.thingUid,
					"thingId": param.thingId,
					"label": param.label,
				};
				HCAP.eventCB["thingDiscovered"](eventObj);
			}
		}
	},
	false
);

document.addEventListener(
	"iot_thing_meta_data_changed",
	function (param) {
		debug.info("Event 'iot_thing_meta_data_changed': thingUid[" + 
			param.thingUid + "], thingMetaData[" + 
			JSON.stringify(param.thingMetaData) + "]");

		if (HCAP.eventCB !== null) {
			if (HCAP.eventCB.hasOwnProperty("thingMetaDataChanged")) {
				var eventObj = {
					"thingUid": param.thingUid,
					"thingMetaData": param.thingMetaData,
				};
				HCAP.eventCB["thingMetaDataChanged"](eventObj);
			}
		}
	},
	false
);

document.addEventListener(
	"iot_thing_registered",
	function (param) {
		debug.info("Event 'iot_thing_registered': bindingId[" + 
			param.bindingId + "], thingUid[" + param.thingUid + "], thingId[" +
			param.thingId + "], thingType[" + param.thingType + 
			"], thingMetaData[" + JSON.stringify(param.thingMetaData) + 
			"], thingComponentList[" + 
			JSON.stringify(param.thingComponentList) + "]");

		if (HCAP.eventCB !== null) {
			if (HCAP.eventCB.hasOwnProperty("thingRegistered")) {
				var eventObj = {
					"bindingId": param.bindingId,
					"thingUid": param.thingUid,
					"thingId": param.thingId,
					"thingType": param.thingType,
					"thingMetaData": param.thingMetaData,
					"thingComponentList": param.thingComponentList,
				};
				HCAP.eventCB["thingRegistered"](eventObj);
			}
		}
	},
	false
);

document.addEventListener(
	"iot_thing_rejected",
	function (param) {
		debug.info("Event 'iot_thing_rejected': thingUid[" + param.thingUid + 
			"]");

		if (HCAP.eventCB !== null) {
			if (HCAP.eventCB.hasOwnProperty("thingRejected")) {
				var eventObj = {
					"thingUid": param.thingUid,
				};
				HCAP.eventCB["thingRejected"](eventObj);
			}
		}
	},
	false
);

document.addEventListener(
	"iot_thing_unregistered",
	function (param) {
		debug.info("Event 'iot_thing_unregistered': thingUid[" + 
			param.thingUid + "]");

		if (HCAP.eventCB !== null) {
			if (HCAP.eventCB.hasOwnProperty("thingUnregistered")) {
				var eventObj = {
					"thingUid": param.thingUid,
				};
				HCAP.eventCB["thingUnregistered"](eventObj);
			}
		}
	},
	false
);

document.addEventListener(
	"iot_binding_ready",
	function (param) {
		debug.info("Event 'iot_binding_ready': bindingId[" + param.bindingId + 
			"]");

		if (HCAP.eventCB !== null) {
			if (HCAP.eventCB.hasOwnProperty("bindingReady")) {
				var eventObj = {
					"bindingId": param.bindingId
				};
				HCAP.eventCB["bindingReady"](eventObj);
			}
		}
	},
	false
);

document.addEventListener(
	"iot_factory_reset_result_received",
	function (param) {
		debug.info("Event 'iot_factory_reset_result_received': " +
			"factoryResetResultList[" + 
			JSON.stringify(param.factoryResetResultList) + "]");

		if (HCAP.eventCB !== null) {
			if (HCAP.eventCB.hasOwnProperty("factoryResetResultReceived")) {
				var eventObj = {
					"factoryResetResultList": param.factoryResetResultList,
				};
				HCAP.eventCB["factoryResetResultReceived"](eventObj);
			}
		}
	},
	false
);


// initialize

var MW = HCAP;
