var RoomNumber = getCookie("roomnumber");
var ChannelList       = {};
var bannertimeout = getCookie("channelbanner_timeout");
var current_channel;
var remote_input = 0;
var banner_ready = false;
//var event_data;
var media;
var event_data_loaded = false;
var channels_loaded = false;
var referrer_matches, back_page_referrer;

function setBackPageReferrer() {
    var referrer = document.referrer;
    //logConsole("referrer: " + referrer);

    referrer_matches = referrer.match(/(\w+)(\.\w+)+(?!.*(\w+)(\.\w+)+)/);
    //logConsole("referrer_matches...." + JSON.stringify(referrer_matches));

    back_page_referrer = referrer_matches[0];
    //logConsole("back_page_referrer: " + back_page_referrer);

    var pos = back_page_referrer.indexOf("channelbanner");
    //logConsole("pos: " + pos);

    if (back_page_referrer.indexOf("channelbanner") == -1 && back_page_referrer.indexOf("debug") == -1 && back_page_referrer.indexOf("popup_007") == -1 && back_page_referrer.indexOf("index") == -1) {
        //logConsole("Updating back_page_referrer to " + back_page_referrer);
        localStorage.setItem("back_page_referrer", back_page_referrer);
    }
    else {
        logConsole("Retaining existing value of back_page_referrer!");
    }
    logConsole("back_page_referrer: " + localStorage.getItem("back_page_referrer"));
}

// Read a page's GET URL variables and return them as an associative array.
function getUrlVars() {
    var vars = [], hash;
    var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
    for(var i = 0; i < hashes.length; i++)
    {
        hash = hashes[i].split('=');
        vars.push(hash[0]);
        vars[hash[0]] = hash[1];
    }
    return vars;
}

function displayBanner(){
    if (!remote_input && banner_ready) {
        $('#wrapper').show();
        $('#rmInput').hide();

        // refresh ch logo
		d = new Date();
		date_suffix = d.getTime();

        // get all images and refresh source
        $.each($("img"), function(i, img) {
			src = $(img).attr("src");
			//logConsole("src before: " + src);

	        if (src.indexOf("?") == -1) {
				src = src + "?" + date_suffix;
	        }

			$(img).attr("src", src);
			//logConsole("src after: " + src);
        });

        remote_input = 0;
        bannertimeout = parseInt(getCookie("channelbanner_timeout"));

        setTimeout(function() {
            hidebanner();
        }, bannertimeout * 1000);
    }
}

function hidebanner() {
    if ( $('#rmInput').css('display') == "none" ) {
        PORTAL_ACTIVE = false;
        $('#wrapper').hide();
        $('#rmInput').hide();
        $('#rmInput').html('');
    }
}

function logout() {
    $('#wrapper').hide();
    $('#rmInput').hide();
    $('#rmInput').html('');
}

function displayRemoteInput(number){
    remote_input = 1;
    logConsole("In displayRemoteInput, entering: " + number);

    if(isVODPlaying()) {
       remote_input = 0;
       return;
    }

    $('#wrapper').hide();
    $('#rmInput').show();

    var oldinput = $('#rmInput').html();

    if (oldinput.length < 3) {
        $('#rmInput').html(oldinput + number);
    }
    else {
        $('#rmInput').html(number);
    }

    setTimeout(function() {
        readRemoteInput();
    }, 3000);
}

function readRemoteInput() {
    new_channel = $('#rmInput').html();

    // Don't display empty channel banner
    if (new_channel.trim() != '') {
        logConsole("Comparing current_channel["+ current_channel +"] to new_channel["+ new_channel +"]");
        // Don't do anything if trying to go channel that already on
        if (parseInt(new_channel) == parseInt(current_channel)) {
            remote_input = 0;
            hidebanner();
            return;
        }
        ch = getPhysicalChannelInfo(new_channel);
        if (Object.keys(ch).length > 0 && ch.type != "SMART_APP" && ch.type != "URL") {
            $(window.frameElement).addClass("hidden");
            changeChannel(ch, null, 0, 'readRemoteInput', null);
            window.location.href = "channelbanner.html?mode=tv&chNum=" + new_channel;
        }
        else {
            $("#chLogo").attr('src', 'images/ChannelIcons/transparent.png');
            $("#chNum").html(new_channel);
            $("#chDesc").html('Invalid channel');

            remote_input = 0;
            displayBanner();

            setTimeout(function() {
                $(window.frameElement).addClass("hidden");
                window.location.href = "channelbanner.html?mode=tv&chNum=" + getCookie("current_channel");
            }, 1000);
        }
    }
}

function init_channel_banner(){
    setBackPageReferrer();

    //logConsole("In channel_banner.js init_channel_banner()");
    //logConsole("Setting cookie 'channelbanner_active'...");
    setCookie("channelbanner_active", "TRUE", COOKIE_EXPIRE_DAYS);
    setChannels();
    // Reset index background settings
    SyncBackgroundSettingsToParent('none');

    if(isVODPlaying()) {
        setBackgroundToBlack();
    }

    //Do not resize if tv is already on that resolution(to prevent flickering)
    hcap.video.getVideoSize({
        "onSuccess" : function(s) {

            if ((projectResolution == 'hd' && s.width != RESOLUTION_WIDTH) ||
                (projectResolution == 'full-hd' && parseInt(s.width) + 1 != parseInt(RESOLUTION_WIDTH))
            ) {
                resizePIPtoFullScreen();
            }
        },
        "onFailure" : function(f) {
            console.log("onFailure : errorMessage = " + f.errorMessage);
        }
    });

    $('#wrapper').hide();
    $('#rmInput').hide();

    try {
        if (!isEditorMode() && !isPreviewMode()) {

            //portal_mode = getCookie("portal_mode");
            vars = getUrlVars();

            current_channel = null;
            if (typeof vars["chNum"] !== "undefined" && vars["chNum"] != '' && vars["chNum"] != 'undefined' && vars["chNum"] != 'NaN') {
                current_channel = vars["chNum"]; // get from url
            }
            else if (getCookie('current_channel') != '') {
                current_channel = getCookie('current_channel');
            }

            hcap_input = null;
            input_index = null;
            portal_mode = '';

            hcap.externalinput.getCurrentExternalInput({
                "mode" : hcap.power.PowerMode.NORMAL,
                "onSuccess" : function(s) {
                    hcap_input = parseInt(s.type);
                    input_index = parseInt(s.index);
                    logConsole("Success! hcap_input: " + hcap_input + ", input_index: " + input_index);

                    logConsole("current_channel: " + current_channel);

                    // Adjust input if VOD
                    if (typeof vars["mode"] !== "undefined" && vars["mode"] == 'VOD' && vars["vod_idx"] != 'undefined' && vars["vod_idx"] != '') {
                        if(isVODPlaying()) {
                           hcap_input = PORTAL_MODE_VOD;
                        }
                    }

                    switch(hcap_input) {
                        case hcap.externalinput.ExternalInputType.TV:
                            logConsole("hcap.externalinput.ExternalInputType.TV");

                            portal_mode = PORTAL_MODE_TV;

                            if(getCookie("switchVODToEPG") == 'true') {
                               setCookie("switchVODToEPG", 'false', COOKIE_EXPIRE_DAYS);
                            }
                            else {
                                hcap.channel.getCurrentChannel({
                                     "onSuccess" : function(s) {
                                         logConsole("onSuccess :" +
                                             "major number      : " + s.majorNumber     +
                                             ", minor number      : " + s.minorNumber     +
                                             ", rf broadcast type : " + s.rfBroadcastType +
                                             ", ip                : " + s.ip              +
                                             ", port              : " + s.port            +
                                             ", ip broadcast type : " + s.ipBroadcastType);

                                             ch = getLogicalChannelInfo(s);
                                             current_channel = ch.logicalChannelNumber;

                                             logConsole("current_channel: " + current_channel);
                                             logConsole("renderChannelBanner(" + portal_mode + ", " + current_channel + ")");
                                     },
                                     "onFailure" : function(f) {
                                         console.log("onFailure : errorMessage = " + f.errorMessage);
                                     }
                                });
                            }
                            break;
                        case PORTAL_MODE_VOD:
                            logConsole("hcap.externalinput.ExternalInputType.VOD");

                            mode = vars["mode"]; // get from url
                            vod_idx = vars["vod_idx"]; // get from url

                            portal_mode = PORTAL_MODE_VOD;
                            current_channel = vod_idx;
                            break;
                        case hcap.externalinput.ExternalInputType.HDMI:
                            logConsole("hcap.externalinput.ExternalInputType.HDMI");
                            if (input_index == 0) {
                                portal_mode = PORTAL_MODE_HDMI_1;
                            }
                            else if (input_index == 1) {
                                portal_mode = PORTAL_MODE_HDMI_2;
                            } 
                            else if (input_index == 2) {
                                portal_mode = PORTAL_MODE_HDMI_3;
                            }
                            else {
                                portal_mode = PORTAL_MODE_HDMI_STD;
                            }

                            break;
                        case hcap.externalinput.ExternalInputType.COMPONENT:
                            logConsole("hcap.externalinput.ExternalInputType.COMPONENT");
                            portal_mode = PORTAL_MODE_COMPONENT;
                            break;
                        case hcap.externalinput.ExternalInputType.COMPOSITE:
                            logConsole("hcap.externalinput.ExternalInputType.COMPOSITE");
                            portal_mode = PORTAL_MODE_COMPOSITE;
                            break;
                        case hcap.externalinput.ExternalInputType.SVIDEO:
                            logConsole("hcap.externalinput.ExternalInputType.SVIDEO");
                            portal_mode = PORTAL_MODE_SVIDEO;
                            break;
                        case hcap.externalinput.ExternalInputType.SCART:
                            logConsole("hcap.externalinput.ExternalInputType.SCART");
                            portal_mode = PORTAL_MODE_SCART;
                            break;
                        default:
                            logConsole("Invalid hcap_input, " + hcap_input);
                            break;
                    }

                    logConsole("renderChannelBanner(" + portal_mode + ", " + current_channel + ")");

                    //set portal mode cookie
                    setCookie("portal_mode", portal_mode, COOKIE_EXPIRE_DAYS);

                    // render channel banner
                    renderChannelBanner(portal_mode, current_channel);
                },
                "onFailure" : function(f) {
                    logConsole("onFailure : errorMessage = " + f.errorMessage);
                }
            });

            success_verify_tune_fx = getSuccessVerifyFx();
            success_verify_tune_fx();
        }
        else {
            logConsole("Data not available in this mode");
        }
    }
    catch(err) {
        logConsole(err);
    }
}

function loadEventData(dummy, data) {
    var eventInfoCompressed = LZString.compress(JSON.stringify(data));
    localStorage.setItem("event_data", eventInfoCompressed);
	event_data_loaded = true;
}

function setEPGData() {
    //logConsole("In START OF PROMISE...");
    var event_data = getLocalStorageObject("event_data");
    var p = new Promise(function(resolve,reject) {
        /******************************************************
        * Check if event_data exists in local storage
        ******************************************************/
        epgfetchdone = getCookie("epgfetchdone");

        if ($.isPlainObject(event_data) && !$.isEmptyObject(event_data)) {
            /* READ FROM LOCAL STORAGE */
            event_data_loaded = true;
            logConsole("{data} Found stored EPG data");
            //logConsole("RESOLVING PROMISE!");
            resolve({});
        }
        else {
            logConsole("{data} Missing EPG data - request from server");
            window.parent.fetchEventData();
            event_data_loaded = true;
            //logConsole("RESOLVING PROMISE!");
            resolve({});
        }
    });

    return p;
}

function getChannelsData(data) {
    logConsole("Setting channels to localStorage in ChannelBanner...");
    var channelInfo = LZString.compress(JSON.stringify(data));
    localStorage.setItem("channellist", channelInfo)
    try {
        setChannels();

        setTimeout(function() {
			init_channel_banner();
        }, 1000);
    }
    catch (e) {
        logConsole(JSON.stringify(e));
    }
}

function renderChannelBanner(portal_mode, current_channel) {
    logConsole("portal_mode: " + portal_mode);
    if (portal_mode == PORTAL_MODE_TV) {

        var channels = getLocalStorageObject("channellist");
        var event_data = getLocalStorageObject("event_data");
        if ($.isPlainObject(channels) && !$.isEmptyObject(channels)) {
            channels_loaded = true;
            //logConsole("Found channels in localStorage");

            setEPGData().then(function(data) {
                //logConsole("In THEN OF PROMISE...");
                if (vars.length && channels_loaded && event_data_loaded) {
                    //logConsole("channels_loaded AND event_data_loaded = TRUE");
                    found_channel = 0;
                    $.each(channels.channels, function(i, channel) {
                        if (channel.logicalChannelNumber == current_channel) {
                            var urlData = getUrlVars();
                            if (urlData["chNum"] !== current_channel){
                                location.href = "channelbanner.html?mode=tv&chNum=" + current_channel;
                            }
                            channelLogo = $('#chLogo');
                            chNum = $("#chNum");
                            chDesc = $("#chDesc");
                            chEventName = $("#chEventName");
                            chEventDuration = $("#chEventDuration");
                            chEventDescription = $("#chEventDescription");

                            //logConsole("channel.logoFileName: " + channel.logoFileName);
                            if(typeof channel.logoFileName == "undefined") {
                                channelLogo.attr('src', 'images/ChannelIcons/transparent.png');
                            } else {
                                channelLogo.attr('src', 'images/ChannelIcons/' + channel.logoFileName);
                            }
                            channelLogo.attr('title', channel.channelLabel.toUpperCase());
                            channelLogo.error(function() {
                                $(this).attr('src', 'images/ChannelIcons/transparent.png');
                            });
                            channelLogo.show();

                            var eventName = '';
                            var duration_label = '';
                            var description_label = '';
                            if(!_.isUndefined(_.get(event_data, 'channels'))) {
                                $.each(event_data.channels, function (j, event_channel) {

                                    if (event_channel.channelNumber == current_channel) {
                                        //logConsole("Matching channel: " + event_channel.channelNumber);
                                        d = new Date();
                                        e_now = d.getTime() / 1000;

                                        $.each(event_channel.events, function (e, event) {
                                            e_start = event.eventStartTime;
                                            e_end = event.eventEndTime;


                                            if (e_start.length == 13) {
                                                e_start = e_start / 1000;
                                            }

                                            if (e_end.length == 13) {
                                                e_end = e_end / 1000;
                                            }

                                            d = convertEpochToDate(e_start);

                                            //logConsole(event.eventName + ": " + d.toLocaleString());

                                            if ((e_now >= e_start && e_now <= e_end) || (e_start == "" && e_end == "") || (parseInt(e_start) == 0 && parseInt(e_end) == 0)) {
                                                eventName = getEPGLanguageValue(event.eventName, getCurrentLanguage());
                                                //logConsole("Matching event: " + eventName);

                                                /* START TIME */
                                                if (e_start != "" && e_start != "") {
                                                    /* START TIME */
                                                    duration_label = getFriendlyEventTime(convertEpochToDate(e_start));

                                                    /* END TIME */
                                                    duration_label = duration_label + ' - ' + getFriendlyEventTime(convertEpochToDate(e_end));
                                                }
                                                description_label = event.eventDescription;

                                                return false;
                                            }
                                        });
                                        return false;
                                    }
                                });
                            }

                            //[pcd2.5] paid channel logo
                            var paidChLogo = $('#paidChLogo');
                            var paidChDuration = $('#paidChEventDuration');
                            if(!_.has(channel, "expireDate")) {
                                paidChLogo.hide();
                                paidChDuration.hide();
                            } else {
                                paidChLogo.show();
                                paidChDuration.html('');
                                paidChDuration.show();

                                var duration =  moment.duration(moment(channel.expireDate).diff(moment()),"ms");
                                paidChDuration.html(getDurationLabel(duration));

                                var count = 0;
                                var durationTimer= setInterval(function(){
                                    count++;

                                    duration =  duration.subtract(1, 's');
                                    paidChDuration.html(getDurationLabel(duration));

                                    if(count == bannertimeout) {
                                        clearInterval(durationTimer);
                                    }
                                }, 1000);


                            }

                            //logConsole("eventName: " + eventName);
                            //logConsole("duration_label: " + duration_label);

                            chNum.html(channel.logicalChannelNumber);
                            chDesc.html(channel.channelLabel.toUpperCase());

                            chEventName.html('');
                            chEventDuration.html('');
                            chEventDescription.html('');

                            if (eventName != '') {
                                chEventName.html(eventName);
                                chEventName.removeClass("pre_render");
                            }
                            if (duration_label != '') {
                                chEventDuration.html(duration_label);
                                chEventDuration.removeClass("pre_render");
                            }
                            if (description_label != '') {
                                chEventDescription.html(description_label);
                                chEventDescription.removeClass("pre_render");
                            }

                            //$("#propertyimage").css('background-image', 'url(images/widget-23/LG_Logo.png)');
                            found_channel = 1;
                            if(!found_channel) {
                                chNum.html(vars["chNum"]);
                                chDesc.html("No data available");
                            }

                            chDesc.removeClass("pre_render");
                            chNum.removeClass("pre_render");
                            channelLogo.removeClass("pre_render");

                            banner_ready = true;

                            displayBanner();
                            return false;
                        }
                    });
                }
                else {
                    logConsole("Unable to display channelbanner. channels_loaded ["+channels_loaded+"], event_data_loaded["+event_data_loaded+"]")
                }

            });
        }
        else {
            logConsole("{data} Channels data is missing, attempting to read channels again");
            loadJSON(getChannelsData, "channels.json");

            return;
        }

    }
    else if (portal_mode == PORTAL_MODE_VOD){
        logConsole("In VOD mode...");

		vod_url = getCookie("vod_url");
		vod_idx = getCookie("vod_idx");
		logConsole("vod_url: " + vod_url);
		logConsole("Initializing mediaPlay....");

        var current_video = {
			title: "VIDEO RESOURCE",
			description: ""
        };

        if (typeof videos_array !== 'undefined') {
	        $.each(videos_array.videos, function(i, video) {
				if (i == parseInt(current_channel) -1) {
					logConsole("Found matching video at idx: " + i);
					logConsole("Playing " + JSON.stringify(video));
					current_video = video;
					return;
				}
	        });
		}
		else {
			logConsole("Unable to find videos_array...");
			return;
		}

		vod_url = "http://" + GLOBAL_SERVER_IP + ":8091/" + current_video.filename;

		logConsole("Activate VOD[" + current_video.filename + "] " + current_video.title);
		logConsole("vod_url: " + vod_url);
		logConsole("encrypted: " + current_video.encrypted);

		mediaPlay(vod_url, current_video.encrypted, 'HTTP');

        chLogo = $('#chLogo');
        chNum = $("#chNum");
        chEventName = $("#chEventName");
        chDesc = $("#chDesc");
        chEventDuration = $("#chEventDuration");
        chEventDescription = $("#chEventDescription");

        // For older projects that have old channelbanner page
        if (chDesc.length) {
            chDesc.html(current_video.title);
        }
        else {
            chEventName.html(current_video.title);
            chEventDescription.html(current_video.description);
        }

        chEventDuration.html('');
        chLogo.hide();
        chNum.hide();

        banner_ready = true;
        displayBanner();
    }
    else if (portal_mode == PORTAL_MODE_HDMI_1){
        logConsole("In HDMI mode...");
        $("#chNum").html('1');
        $("#chDesc").html('HDMI');
        $('#chLogo').hide();
        $("#chEventName").html('HDMI');
        $("#chEventDuration").html('');
        $("#chEventDescription").html('');

        banner_ready = true;
        displayBanner();
    }
    else if (portal_mode == PORTAL_MODE_HDMI_2){
        logConsole("In HDMI mode...");
        $("#chNum").html('2');
        $("#chDesc").html('HDMI');
        $('#chLogo').hide();
        $("#chEventName").html('HDMI');
        $("#chEventDuration").html('');
        $("#chEventDescription").html('');

        banner_ready = true;
        displayBanner();
    }
    else if (portal_mode == PORTAL_MODE_HDMI_3){
        logConsole("In HDMI mode...");
        $("#chNum").html('3');
        $("#chDesc").html('HDMI');
        $('#chLogo').hide();
        $("#chEventName").html('HDMI');
        $("#chEventDuration").html('');
        $("#chEventDescription").html('');

        banner_ready = true;
        displayBanner();
    }
    else if (portal_mode == PORTAL_MODE_HDMI_STD) {
        logConsole("In HDMI mode...");
        $("#chNum").html('');
        $("#chDesc").html('HDMI');
        $('#chLogo').hide();
        $("#chEventName").html('HDMI');
        $("#chEventDuration").html('');
        $("#chEventDescription").html('');

        banner_ready = true;
        displayBanner();
    }
    else if (portal_mode == PORTAL_MODE_COMPONENT) {
        logConsole("In COMPONENT mode...");
        $("#chNum").html('');
        $("#chDesc").html('AV/COMPONENT');
        $('#chLogo').hide();
        $("#chEventName").html('AV/COMPONENT');
        $("#chEventDuration").html('');
        $("#chEventDescription").html('');

        banner_ready = true;
        displayBanner();
    }
    else if (portal_mode == PORTAL_MODE_COMPOSITE) {
        logConsole("In COMPOSITE/AV mode...");
        $("#chNum").html('');
        $("#chDesc").html('AV/COMPOSITE');
        $('#chLogo').hide();
        $("#chEventName").html('AV/COMPOSITE');
        $("#chEventDuration").html('');
        $("#chEventDescription").html('');

        banner_ready = true;
        displayBanner();
    }
    else if (portal_mode == PORTAL_MODE_SVIDEO) {
        logConsole("In SVIDEO mode...");
        $("#chNum").html('');
        $("#chDesc").html('SVIDEO');
        $('#chLogo').hide();
        $("#chEventName").html('SVIDEO');
        $("#chEventDuration").html('');
        $("#chEventDescription").html('');

        banner_ready = true;
        displayBanner();
    }
    else if (portal_mode == PORTAL_MODE_SCART) {
        logConsole("In SCART mode...");
        $("#chNum").html('');
        $("#chDesc").html('AV/SCART');
        $('#chLogo').hide();
        $("#chEventName").html('AV/SCART');
        $("#chEventDuration").html('');
        $("#chEventDescription").html('');

        banner_ready = true;
        displayBanner();
    }
    else {
        logConsole("In Unsupported mode...");
        $("#chNum").html('');
        $("#chDesc").html('');
        $('#chLogo').hide();
        $("#chEventName").html('');
        $("#chEventDuration").html('');
        $("#chEventDescription").html('');

        banner_ready = true;
        displayBanner();
    }

    if(portal_mode !== PORTAL_MODE_TV){
        $('#paidChLogo').hide();
        $('#paidChEventDuration').hide();
    }

    success_verify_tune_fx = getSuccessVerifyFx();
    success_verify_tune_fx();
}

function convertEpochToDate(utcSeconds) {
	var d = new Date(0); // The 0 there is the key, which sets the date to the epoch
	d.setUTCSeconds(utcSeconds);

	return d;
}

function getFriendlyEventTime(d) {
	time_label = 'AM';
	hour_label = d.getHours();
	minute_label = d.getMinutes();

	if (hour_label == 0) {
		time_label = 'AM';
		hour_label = '12';
	}
	else if (hour_label == 12) {
		time_label = 'PM';
	}
	else if (hour_label > 12) {
		time_label = 'PM';
		hour_label = hour_label - 12;
	}

	if (minute_label > 0) {
		minute_label = (minute_label <10?'0':'') + minute_label;
		parsed_time = hour_label + ":" + minute_label + ' ' + time_label;
	}
	else {
		parsed_time = hour_label + ":00" + ' ' + time_label;
	}

	return parsed_time;
}

function getDurationLabel(_duration){
    return _duration > 0 ? (Math.floor(_duration.as('h')) + moment.utc(_duration.as('ms')).format(':mm:ss')) : "";  //h:mm:ss
}

document.addEventListener(
     "external_input_changed",
     function() {
         logConsole("Event 'external_input_changed' is received");
         if(!PORTAL_ACTIVE && getCookie("guide_to_page") == 0 && getCookie("guide_to_channel") == 0 && !isVODPlaying()) {

             hcap.channel.getCurrentChannel({
                 "onSuccess" : function(s) {
                     /*logConsole("SUCCESS :" +
                      "<br /> logical number    : " + s.logicalNumber   +
                      "<br /> program number    : " + s.programNumber   +
                      "<br /> major number      : " + s.majorNumber     +
                      "<br /> minor number      : " + s.minorNumber     +
                      "<br /> rf broadcast type : " + s.rfBroadcastType +
                      "<br /> ip                : " + s.ip);*/

                     var ch = getLogicalChannelInfo(s);

                     if(ch.hasOwnProperty("logicalChannelNumber")) {
                         current_channel = ch.logicalChannelNumber;
                         setCookie("current_channel", current_channel, COOKIE_EXPIRE_DAYS);

                         hcap_ready = 1;

                         $(window.frameElement).addClass("hidden");
                         window.location.href = "channelbanner.html?mode=tv&chNum=" + current_channel;
                     } else {
                         $(window.frameElement).addClass("hidden");
                         location.reload();
                     }
                 },
                 "onFailure" : function(f) {
                     logConsole("FAILURE in getCurrentConfigChannel!");
                     $(window.frameElement).addClass("hidden");
                     location.reload();
                 }
             });

         }
     },
     false
);